module Lambdable
  extend ActiveSupport::Concern

  def tags
    @tags ||= { }
  end

  def version(*attrs)
    tags.merge! 'x-amz-meta-process-size-versions' => attrs.join(';')
  end

  def type(*attrs)
    tags.merge! 'x-amz-meta-process-image-type' => attrs.join(';')
  end

  def sqs
    if model.app_id
      tags.merge! 'x-amz-meta-process-sqs' => "events|#{routing_key}|#{message}|#{event}"
    else
      tags
    end
  end

  def routing_key
    "apps.#{model.app_id}.media.#{model.class.name.underscore}.#{model.id}.processed"
  end

  def event
    "#{model.class.name.underscore.upcase}_PROCESSED"
  end

  def message
    ActiveModelSerializers::SerializableResource.new(model).to_json
  end
end
